/**
 * Copyright © 2009-2010 Kirill Gavrilov <kirill@sview.ru>
 *
 * StCore library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * StCore library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library.
 * If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __StApplicationImpl_h_
#define __StApplicationImpl_h_

#include <StCore/StApplicationInterface.h>
#include <StCore/StMessageList.h>
#include <StCore/StRendererPlugin.h>
#include <StLibrary.h>

class ST_LOCAL StApplicationImpl : public StApplicationInterface {

        private:

    StRendererPlugin     stRenderer;

    StString           sViewPath;

    StString     stParamRenderer;
    StString stParamDeviceString;
    int            stParamDeviceInt;

    StOpenInfo         stDrawerInfo; // StDrawer plugin to open (may be empty for autodetection)
    StOpenInfo       stOpenFileInfo; // file to open
    StNativeWin_t stNativeWinParent;

    StString      showHelpString;

    StMessage_t stMessages[StMessageList::BUFFER_SIZE + 1];

    bool bOpened;
    bool bQuit;

        public:

    // exports
    StApplicationInterface* getLibImpl() { return this; }
    StApplicationImpl();
    ~StApplicationImpl();
    bool isOpened() { return bOpened; }
    bool create(const StNativeWin_t* );
    bool open(const StOpenInfo& );
    void callback(StMessage_t* );

        private:

    // additional
    bool chooseRendererPlugin();
    void parseProcessArguments();

};

#endif //__StApplication_h_
