/**
 * Copyright © 2007-2012 Kirill Gavrilov <kirill@sview.ru>
 *
 * Distributed under the Boost Software License, Version 1.0.
 * See accompanying file license-boost.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt
 */

#include <StSettings/StConfig.h>
#include <StLibrary.h>

StConfig::ConfigFunctions::ConfigFunctions() {
    nullify();
}

void StConfig::ConfigFunctions::load(StLibrary& theLib) {
    theLib("StConfig_new",        StConfig_new);
    theLib("StConfig_del",        StConfig_del);
    theLib("StConfig_loadInt32",  StConfig_loadInt32);
    theLib("StConfig_saveInt32",  StConfig_saveInt32);
    theLib("StConfig_loadString", StConfig_loadString);
    theLib("StConfig_saveString", StConfig_saveString);
}

bool StConfig::ConfigFunctions::isNull() const {
    return StConfig_new  == NULL       || StConfig_del == NULL
        || StConfig_loadInt32 == NULL  || StConfig_saveInt32 == NULL
        || StConfig_loadString == NULL || StConfig_saveString == NULL;
}

void StConfig::ConfigFunctions::nullify() {
    stMemSet(this, 0, sizeof(*this));
}

namespace {
    static StConfig::ConfigFunctions ST_CONFIG_FUNCTIONS;
};

StConfig::ConfigFunctions& StConfig::GetFunctions() {
    return ST_CONFIG_FUNCTIONS;
}
