/**
 * Copyright © 2010-2011 Kirill Gavrilov <kirill@sview.ru>
 *
 * Distributed under the Boost Software License, Version 1.0.
 * See accompanying file license-boost.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt
 */

#ifndef __StGLCircle_h_
#define __StGLCircle_h_

#include "StGLMesh.h"

class ST_LOCAL StGLCircle : public StGLMesh {

        private:

    StGLVec3 myCenter;
    GLfloat myRadiusX;
    GLfloat myRadiusY;
    GLsizei myPointsCount;

        public:

    /**
     * Initialize the invalid circle.
     */
    StGLCircle();

    StGLCircle(const StGLVec3& theCenter,
               GLfloat theRadius,
               GLsizei thePointsCount);

    virtual ~StGLCircle();

    void create(const StGLVec3& theCenter,
                GLfloat theRadius,
                GLsizei thePointsCount);

    void create(const StGLVec3& theCenter,
                GLfloat theRadiusX,
                GLfloat theRadiusY,
                GLsizei thePointsCount);

    /**
     * Compute the mesh using current configuration.
     */
    virtual bool computeMesh();

    /**
     * Initialize the colors array with one specified color.
     * Mesh should be already initialized before.
     * @param theColor (const StGLVec4& ) - the color to set.
     */
    bool initColorsArray(const StGLVec4& theColor);

};

#endif //__StGLCircle_h_
