/**
 * Copyright © 2007-2010 Kirill Gavrilov
 *
 * Distributed under the Boost Software License, Version 1.0.
 * See accompanying file license-boost.txt or copy at
 * http://www.boost.org/LICENSE_1_0.txt
 */

#ifndef __StSettings_h_
#define __StSettings_h_

#include <StSettings/StConfig.h>
#include <StThreads/StMutex.h>
#include <StLibrary.h>

class ST_LOCAL StSettings : public StConfig {

        private:

    static StLibrary& GetLibrary();
    static StMutex&   GetMutex();      // private mutex to process multiple library INIT/FREE
    static size_t&    GetUseCounter(); // private counter to process multiple library INIT/FREE

        public:

    StSettings(const StString& settingsSet);
    virtual ~StSettings();

    // INIT library function - called by host application to use library classes
    static int  INIT();
    static void FREE();

};

#endif //__StSettings_h_
